## samba 4.3.9+dfsg

=== source3/wscript ===
#!/usr/bin/env python

srcdir=".."

import sys, os
from optparse import SUPPRESS_HELP
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
sys.path.insert(0, "source3")
import wafsamba, Options, Logs, Utils, Scripting
import build.charset
import samba_utils, samba_version
import samba3

Options.default_prefix = '/usr/local/samba'

def set_options(opt):

    opt.add_option('--with-static-modules',
                   help=("Comma-separated list of names of modules to statically link in"),
                   action="store", dest='static_modules', default=None)
    opt.add_option('--with-shared-modules',
                   help=("Comma-separated list of names of modules to build shared"),
                   action="store", dest='shared_modules', default=None)

    opt.SAMBA3_ADD_OPTION('winbind')
    opt.SAMBA3_ADD_OPTION('ads')
    opt.SAMBA3_ADD_OPTION('ldap')
    opt.SAMBA3_ADD_OPTION('cups', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iprint', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('pam')
    opt.SAMBA3_ADD_OPTION('pam_smbpass')
    opt.SAMBA3_ADD_OPTION('quotas')
    opt.SAMBA3_ADD_OPTION('sendfile-support')
    opt.SAMBA3_ADD_OPTION('utmp')
    opt.SAMBA3_ADD_OPTION('pthreadpool', with_name="enable", without_name="disable", default=True)
    opt.SAMBA3_ADD_OPTION('avahi', with_name="enable", without_name="disable")
    opt.SAMBA3_ADD_OPTION('iconv')
    opt.SAMBA3_ADD_OPTION('acl-support')
    opt.SAMBA3_ADD_OPTION('dnsupdate')
    opt.SAMBA3_ADD_OPTION('syslog')
    opt.SAMBA3_ADD_OPTION('automount')
    opt.SAMBA3_ADD_OPTION('aio-support')
    opt.SAMBA3_ADD_OPTION('dmapi', default=None) # None means autodetection
    opt.SAMBA3_ADD_OPTION('fam', default=None) # None means autodetection
    opt.SAMBA3_ADD_OPTION('profiling-data', default=False)
    opt.SAMBA3_ADD_OPTION('libarchive', default=None)

    opt.SAMBA3_ADD_OPTION('cluster-support', default=None)

    opt.SAMBA3_ADD_OPTION('regedit', default=None)

    opt.SAMBA3_ADD_OPTION('fake-kaserver',
                          help=("Include AFS fake-kaserver support"), default=False)

    opt.add_option('--with-libcephfs',
                   help=("Directory under which libcephfs is installed"),
                   action="store", dest='libcephfs_dir', default=None)

    opt.SAMBA3_ADD_OPTION('glusterfs', with_name="enable", without_name="disable", default=True)

    opt.add_option('--enable-vxfs',
                  help=("enable support for VxFS (default=no)"),
                  action="store_true", dest='enable_vxfs', default=False)

    opt.SAMBA3_ADD_OPTION('spotlight', with_name="enable", without_name="disable", default=False)

def configure(conf):
    from samba_utils import TO_LIST

    default_static_modules = []
    default_shared_modules = []

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
        conf.env.developer = True

    if sys.platform != 'openbsd5':
        conf.ADD_LDFLAGS("-Wl,--export-dynamic", testflags=True)

    conf.CHECK_HEADERS('execinfo.h libexc.h libunwind.h netdb.h')
    conf.CHECK_HEADERS('linux/falloc.h linux/ioctl.h')

    conf.CHECK_FUNCS('getcwd fchown chmod fchmod mknod')
    conf.CHECK_FUNCS('strtol strchr strupr chflags')
    conf.CHECK_FUNCS('getrlimit fsync fdatasync setpgid')
    conf.CHECK_FUNCS('setsid glob strpbrk crypt16 getauthuid')
    conf.CHECK_FUNCS('innetgr')
    conf.CHECK_FUNCS('initgroups select poll rdchk getgrnam getgrent pathconf')
    conf.CHECK_FUNCS('setpriv setgidx setuidx setgroups syscall sysconf')
    conf.CHECK_FUNCS('atexit grantpt posix_openpt fallocate posix_fallocate')
    conf.CHECK_FUNCS('fseeko setluid')
    conf.CHECK_FUNCS('getpwnam', headers='sys/types.h pwd.h')
    conf.CHECK_FUNCS('fdopendir')
    conf.CHECK_FUNCS('fstatat')
    conf.CHECK_FUNCS('getpwent_r setenv strcasecmp fcvt fcvtl')
    conf.CHECK_FUNCS('syslog vsyslog timegm setlocale')
    conf.CHECK_FUNCS_IN('nanosleep', 'rt')
    conf.CHECK_FUNCS('lutimes futimes utimensat futimens')
    conf.CHECK_FUNCS('mlock munlock mlockall munlockall')
    conf.CHECK_FUNCS('memalign posix_memalign hstrerror')
    conf.CHECK_FUNCS('shmget')
    conf.CHECK_FUNCS_IN('shm_open', 'rt', checklibc=True)
    #FIXME: for some reason this one still fails
    conf.CHECK_FUNCS_IN('yp_get_default_domain', 'nsl')
    conf.CHECK_FUNCS_IN('dn_expand _dn_expand __dn_expand', 'resolv')
    conf.CHECK_FUNCS_IN('dn_expand', 'inet')
    conf.CHECK_DECLS('fdatasync', reverse=True)
    conf.CHECK_DECLS('readahead', reverse=True, headers='fcntl.h')

    if conf.CHECK_CODE('''
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
long ret = splice(0,0,1,0,400,SPLICE_F_MOVE);
''',
        'HAVE_LINUX_SPLICE',
        headers='fcntl.h'):
        conf.CHECK_DECLS('splice', reverse=True, headers='fcntl.h')

    # Check for inotify support (Skip if we are SunOS)
    #NOTE: illumos provides sys/inotify.h but is not an exact match for linux
    host_os = sys.platform
    if host_os.rfind('sunos') == -1:
        conf.CHECK_HEADERS('sys/inotify.h')
        if "HAVE_SYS_INOTIFY_H" in conf.env:
           conf.DEFINE('HAVE_INOTIFY', 1)

    # Check for kernel change notify support
    conf.CHECK_CODE('''
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_CHANGE_NOTIFY', addmain=False, execute=True,
        headers='fcntl.h signal.h',
        msg="Checking for kernel change notify support")

    # Check for Linux kernel oplocks
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#ifndef F_NOTIFY
#define F_NOTIFY 1026
#endif
main() {
        exit(fcntl(open("/tmp", O_RDONLY), F_NOTIFY, 0) == -1 ?  1 : 0);
}''', 'HAVE_KERNEL_OPLOCKS_LINUX', addmain=False, execute=True,
        msg="Checking for Linux kernel oplocks")

    # Check for IRIX kernel oplock types
    conf.CHECK_CODE('oplock_stat_t t; t.os_state = OP_REVOKE; t.os_dev = 1; t.os_ino = 1;',
                    'HAVE_KERNEL_OPLOCKS_IRIX', headers='fcntl.h',
                    msg="Checking for IRIX kernel oplock types")

    # Check for kernel share modes
    conf.CHECK_CODE('''
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/file.h>
#ifndef LOCK_MAND
#define LOCK_MAND        32
#define LOCK_READ        64
#endif
main() {
        exit(flock(open("/dev/null", O_RDWR), LOCK_MAND|LOCK_READ) != 0);
}''', 'HAVE_KERNEL_SHARE_MODES', addmain=False, execute=True,
        msg="Checking for kernel share modes")

    # check for fam libs
    samba_fam_libs=None
    check_for_fam=False
    if Options.options.with_fam is None:
        check_for_fam=True
    elif Options.options.with_fam == True:
        check_for_fam=True

    if check_for_fam and conf.CHECK_HEADERS('fam.h'):
        if conf.CHECK_FUNCS_IN('FAMOpen2', 'fam'):
            samba_fam_libs='fam'
        elif conf.CHECK_FUNCS_IN('FAMOpen2', 'fam C'):
            samba_fam_libs='fam C'
        conf.CHECK_TYPE('enum FAMCodes', headers='fam.h',
            define='HAVE_FAM_H_FAMCODES_TYPEDEF',
            msg='Checking whether enum FAMCodes is available')
        conf.CHECK_FUNCS_IN('FAMNoExists', 'fam')

    if samba_fam_libs is not None:
        conf.DEFINE('SAMBA_FAM_LIBS', samba_fam_libs)
    else:
        if Options.options.with_fam == True:
            conf.fatal('FAM support requested, but no suitable FAM library found')
        elif check_for_fam:
            Logs.warn('no suitable FAM library found')

    # check for libarchive (tar command in smbclient)
    # None means autodetect, True/False means enable/disable
    conf.env['archive_lib'] = ''
    if Options.options.with_libarchive is not False:
        libarchive_mandatory = Options.options.with_libarchive == True
        Logs.info("Checking for libarchive existence")
        if conf.CHECK_BUNDLED_SYSTEM('libarchive', minversion='3.1.2'):
            conf.env['archive_lib'] = 'libarchive'
        elif libarchive_mandatory:
            conf.fatal('libarchive support requested, but no suitable pkgconfig found')

    # check for DMAPI libs
    if Options.options.with_dmapi == False:
        have_dmapi = False
    else:
        have_dmapi = True
        Logs.info("Checking for DMAPI library existence")
        samba_dmapi_lib = ''
        if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dm'):
            samba_dmapi_lib = 'dm'
        else:
            if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'jfsdm'):
                samba_dmapi_lib = 'jfsdm'
            else:
                if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'dmapi'):
                    samba_dmapi_lib = 'dmapi'
                else:
                    if conf.CHECK_FUNCS_IN('dm_get_eventlist', 'xdsm'):
                        samba_dmapi_lib = 'xdsm'
        # only bother to test headers and compilation when a candidate
        # library has been found
        if samba_dmapi_lib == '':
            have_dmapi = False
            broken_dmapi = "no suitable DMAPI library found"

        if have_dmapi:
            conf.CHECK_HEADERS('sys/dmi.h xfs/dmapi.h sys/jfsdmapi.h sys/dmapi.h dmapi.h')
            conf.CHECK_CODE('''
#include <time.h>      /* needed by Tru64 */
#include <sys/types.h> /* needed by AIX */
#ifdef HAVE_XFS_DMAPI_H
#include <xfs/dmapi.h>
#elif defined(HAVE_SYS_DMI_H)
#include <sys/dmi.h>
#elif defined(HAVE_SYS_JFSDMAPI_H)
#include <sys/jfsdmapi.h>
#elif defined(HAVE_SYS_DMAPI_H)
#include <sys/dmapi.h>
#elif defined(HAVE_DMAPI_H)
#include <dmapi.h>
#endif

/* This link test is designed to fail on IRI 6.4, but should
 * succeed on Linux, IRIX 6.5 and AIX.
 */
int main(int argc, char **argv)
{
	char * version;
	dm_eventset_t events;
	/* This doesn't take an argument on IRIX 6.4. */
	dm_init_service(&version);
	/* IRIX 6.4 expects events to be a pointer. */
	DMEV_ISSET(DM_EVENT_READ, events);

	return 0;
}
''',
            'USEABLE_DMAPI_LIBRARY',
            addmain=False,
            execute=False,
            lib=samba_dmapi_lib,
            msg='Checking whether DMAPI lib '+samba_dmapi_lib+' can be used')
            if not conf.CONFIG_SET('USEABLE_DMAPI_LIBRARY'):
                have_dmapi = False
                broken_dmapi = "no usable DMAPI library found"

    if have_dmapi:
        Logs.info("Building with DMAPI support.")
        conf.env['dmapi_lib'] = samba_dmapi_lib
        conf.DEFINE('USE_DMAPI', 1)
    else:
        if Options.options.with_dmapi == False:
            Logs.info("Building without DMAPI support (--without-dmapi).")
        elif Options.options.with_dmapi == True:
            Logs.error("DMAPI support not available: " + broken_dmapi)
            conf.fatal('DMAPI support requested but not found.');
        else:
            Logs.warn("Building without DMAPI support: " + broken_dmapi)
        conf.env['dmapi_lib'] = ''

    # Check for various members of the stat structure
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_blocks', define='HAVE_STAT_ST_BLOCKS',
                                headers='sys/stat.h')
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_blksize', define='HAVE_STAT_ST_BLKSIZE',
                                headers='sys/stat.h')
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_flags', define='HAVE_STAT_ST_FLAGS',
                                headers='sys/types.h sys/stat.h unistd.h')

    if "HAVE_BLKCNT_T" in conf.env:
        conf.CHECK_CODE('''
        static int test_array[1 - 2 * !(((long int)(sizeof(blkcnt_t))) <= 4)];''',
                'SIZEOF_BLKCNT_T_4',
                headers='replace.h sys/types.h sys/stat.h unistd.h',
                msg="Checking whether blkcnt_t is 32 bit")

    # If sizeof is 4 it can't be 8
    if "HAVE_BLKCNT_T" in conf.env:
        if not conf.CONFIG_SET('SIZEOF_BLKCNT_T_4'):
            conf.CHECK_CODE('''
            static int test_array[1 - 2 * !(((long int)(sizeof(blkcnt_t))) <= 8)];''',
                    'SIZEOF_BLKCNT_T_8',

=== debian/changelog ===
samba (2:4.3.9+dfsg-0ubuntu0.15.10.2) wily-security; urgency=medium

  * SECURITY REGRESSION: NTLM authentication issues (LP: #1578576)
    - debian/patches/samba-bug11912.patch: let msrpc_parse() return
      talloc'ed empty strings in libcli/auth/msrpc_parse.c.
    - debian/patches/samba-bug11914.patch: make
      ntlm_auth_generate_session_info() more complete in
      source3/utils/ntlm_auth.c.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 20 May 2016 08:09:44 -0400

samba (2:4.3.9+dfsg-0ubuntu0.15.10.1) wily-security; urgency=medium

  * SECURITY REGRESSION: Updated to 4.3.9 to fix multiple regressions in
    the previous security updates. (LP: #1577739)
    - debian/control: bump tevent Build-Depends to 0.9.28.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 03 May 2016 09:55:17 -0400

samba (2:4.3.8+dfsg-0ubuntu0.15.10.2) wily-security; urgency=medium

  * SECURITY UPDATE: Updated to 4.3.8 to fix multiple security issues
    - CVE-2015-5370: Multiple errors in DCE-RPC code
    - CVE-2016-2110: Man in the middle attacks possible with NTLMSSP
    - CVE-2016-2111: NETLOGON Spoofing Vulnerability
    - CVE-2016-2112: The LDAP client and server don't enforce integrity
      protection
    - CVE-2016-2113: Missing TLS certificate validation allows man in the
      middle attacks
    - CVE-2016-2114: "server signing = mandatory" not enforced
    - CVE-2016-2115: SMB client connections for IPC traffic are not
      integrity protected
    - CVE-2016-2118: SAMR and LSA man in the middle attacks possible
  * Backported most packaging changes from (2:4.3.6+dfsg-1ubuntu1) in
    Ubuntu 16.04 LTS, except for the following:
    - Don't remove samba-doc package
    - Don't remove libpam-smbpass package
    - Don't remove libsmbsharemodes0 and libsmbsharemodes-dev packages
    - Don't build with dh-systemd
    - Don't build ctdb and cluster support
  * debian/patches/fix_pam_smbpass.patch: fix double free in pam_smbpass.
  * debian/patches/winbind_trusted_domains.patch: make sure domain members
    can talk to trusted domains DCs.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 12 Apr 2016 07:23:27 -0400

samba (2:4.1.17+dfsg-4ubuntu3.3) wily-security; urgency=medium

  * SECURITY UPDATE: incorrect ACL get/set allowed on symlink path
    - debian/patches/CVE-2015-7560-pre1.patch: add vfs_stat_smb_basename()
      to source3/smbd/proto.h, source3/smbd/vfs.c.
    - debian/patches/CVE-2015-7560.patch: properly handle symlinks in
      source3/client/client.c, source3/libsmb/clifile.c,
      source3/libsmb/proto.h, source3/smbd/nttrans.c,
      source3/smbd/trans2.c, added tests to selftest/knownfail,
      source3/selftest/tests.py, source3/torture/torture.c.
    - CVE-2015-7560
  * SECURITY UPDATE: out-of-bounds read in internal DNS server
    - debian/patches/CVE-2016-0771.patch: fix dns handling in
      librpc/idl/dns.idl, librpc/idl/dnsp.idl, librpc/idl/dnsserver.idl,
      librpc/ndr/ndr_dns.c, librpc/ndr/ndr_dnsp.c, librpc/ndr/ndr_dnsp.h,
      librpc/wscript_build, source4/dns_server/dns_query.c,
      source4/dns_server/dns_update.c, source4/librpc/wscript_build,
      added tests to python/samba/tests/dns.py,
      python/samba/tests/get_opt.py, selftest/tests.py,
      source4/selftest/tests.py.
    - CVE-2016-0771

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 03 Mar 2016 09:41:49 -0500

samba (2:4.1.17+dfsg-4ubuntu3.2) wily-security; urgency=medium

  * Fixes regression introduced by debian/patches/CVE-2015-5252.patch.
    (LP: #1545750)

 -- Dariusz Gadomski <dariusz.gadomski@canonical.com>  Mon, 15 Feb 2016 16:10:40 +0100

samba (2:4.1.17+dfsg-4ubuntu3.1) wily-security; urgency=medium

  * SECURITY UPDATE: denial of service in ldb_wildcard_compare function
    - debian/patches/CVE-2015-3223.patch: handle empty strings and
      embedded zeros in lib/ldb/common/ldb_match.c.
    - CVE-2015-3223
  * SECURITY UPDATE: file-access restrictions bypass via symlink
    - debian/patches/CVE-2015-5252.patch: validate matching component in
      source3/smbd/vfs.c.
    - CVE-2015-5252
  * SECURITY UPDATE: man-in-the-middle attack via encrypted-to-unencrypted
    downgrade
    - debian/patches/CVE-2015-5296.patch: force signing in
      libcli/smb/smbXcli_base.c, source3/libsmb/clidfs.c,
      source3/libsmb/libsmb_server.c.
    - CVE-2015-5296
  * SECURITY UPDATE: snapshot access via shadow copy directory
    - debian/patches/CVE-2015-5299.patch: fix missing access checks in
      source3/modules/vfs_shadow_copy2.c.
    - CVE-2015-5299
  * SECURITY UPDATE: information leak via incorrect string length handling
    - debian/patches/CVE-2015-5330.patch: fix string length handling in
      lib/ldb/common/ldb_dn.c, lib/util/charset/charset.h,
      lib/util/charset/codepoints.c, lib/util/charset/util_str.c,
      lib/util/charset/util_unistr.c.
    - CVE-2015-5330
  * SECURITY UPDATE: LDAP server denial of service
    - debian/patches/CVE-2015-7540.patch: check returns in lib/util/asn1.c,
      libcli/ldap/ldap_message.c, libcli/ldap/ldap_message.h,
      source4/libcli/ldap/ldap_controls.c.
    - CVE-2015-7540
  * SECURITY UPDATE: access restrictions bypass in machine account creation
    - debian/patches/CVE-2015-8467.patch: restrict swapping between account
      types in source4/dsdb/samdb/ldb_modules/samldb.c.
    - CVE-2015-8467
  * debian/control: bump libldb-dev Build-Depends to security update
    version.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 Jan 2016 09:30:56 -0500

samba (2:4.1.17+dfsg-4ubuntu3) wily; urgency=medium

  * debian/samba.logrotate:
    - revert to Debian version of the logrotate reload command, fix an 
      invalid syntax introduced in the upstart->systemd transition 
      (lp: #1385868)

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 10 Nov 2015 19:04:30 +0100

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Christian Perrier <bubulle@debian.org>,
           Jelmer Vernooij <jelmer@debian.org>,
           Ivo De Decker <ivodd@debian.org>,
           Mathieu Parent <sathieu@debian.org>
Homepage: http://www.samba.org
Standards-Version: 3.9.7
Build-Depends: bison,
               debhelper (>> 9),
               docbook-xml,
               docbook-xsl,
               faketime,
               flex,
               libacl1-dev,
               libaio-dev [linux-any],
               libarchive-dev,
               libattr1-dev,
               libblkid-dev,
               libbsd-dev,
               libcap-dev [linux-any],
               libcups2-dev,
               libgnutls-dev,
               libheimntlm0-heimdal (>= 1.6~),
               libldap2-dev,
               libldb-dev (>= 2:1.1.21~),
               libncurses5-dev,
               libpam0g-dev,
               libparse-yapp-perl,
               libpcap-dev [hurd-i386 kfreebsd-any],
               libpopt-dev,
               libreadline-dev,
               libtalloc-dev (>= 2.1.3~),
               libtdb-dev (>= 1.3.7~),
               libtevent-dev (>= 0.9.28~),
               perl,
               perl-modules,
               pkg-config,
               po-debconf,
               python-all-dev (>= 2.6.6-3),
               python-dnspython,
               python-ldb (>= 2:1.1.21~),
               python-ldb-dev (>= 2:1.1.21~),
               python-talloc-dev (>= 2.1.3~),
               python-tdb (>= 1.3.7~),
               python-testtools,
               python3,
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-samba/samba.git
Vcs-Git: git://anonscm.debian.org/pkg-samba/samba.git -b master
XS-Testsuite: autopkgtest

Package: samba
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: adduser,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         lsb-base (>= 4.1+Debian),
         procps,
         python,
         python-dnspython,
         python-samba,
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         update-inetd,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: attr, logrotate, samba-dsdb-modules, samba-vfs-modules
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ldb-tools,
          ntp,
          smbldap-tools,
          winbind,
          ufw
Enhances: bind9, ntp
Breaks: qtsmbstatus-server (<< 2.2.1-3~)
Replaces: libsamdb0 (<< 4.0.0~alpha17~),
          python-samba (<< 2:4.1.4+dfsg-3),
          samba-ad-dc,
          samba-common (<= 2.0.5a-2),
          samba-doc (<< 2:4.0.5~),
          samba-libs (<< 2:4.1.4+dfsg-2),
          samba4
Conflicts: libldb1 (<< 1:1.1.15),
           samba (<< 2:3.3.0~rc2-5),
           samba-ad-dc,
           samba-doc (<< 2:4.0.5~),
           samba-tools,
           samba4 (<< 4.0.0~alpha6-2)
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an NT4-style domain controller, and can integrate with both NT4 domains
 and Active Directory realms as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 or Active Directory domain controller.
 For use in an NT4 domain or Active Directory realm, you will also need the
 winbind package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${ldb:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: libdcerpc-server0 (<< 2:4.0.9),
        libdcerpc0 (<< 2:4.0.9),
        libgensec0 (<< 2:4.0.9),
        libndr-standard0 (<< 2:4.0.9),
        libndr0 (<< 2:4.0.9),
        libnetapi0 (<< 2:4.0.9),
        libregistry0 (<< 2:4.0.9),
        libsamba-credentials0 (<< 2:4.0.9),
        libsamba-hostconfig0 (<< 2:4.0.9),
        libsamba-policy0 (<< 2:4.0.9),
        libsamba-util0 (<< 2:4.0.9),
        libsamdb0 (<< 2:4.0.9),
        libsmbclient-raw0 (<< 2:4.0.9),
        libsmbd0 (<< 2:4.0.9),
        libtorture0 (<< 2:4.0.9)
Replaces: libdcerpc-server0 (<< 2:4.0.9),
          libdcerpc0 (<< 2:4.0.9),
          libgensec0 (<< 2:4.0.9),
          libndr-standard0 (<< 2:4.0.9),
          libndr0 (<< 2:4.0.9),
          libnetapi0 (<< 2:4.0.9),
          libregistry0 (<< 2:4.0.9),
          libsamba-credentials0 (<< 2:4.0.9),
          libsamba-hostconfig0 (<< 2:4.0.9),
          libsamba-policy0 (<< 2:4.0.9),
          libsamba-util0 (<< 2:4.0.9),
          libsamdb0 (<< 2:4.0.9),
          libsmbclient-raw0 (<< 2:4.0.9),
          libsmbd0 (<< 2:4.0.9),
          libtorture0 (<< 2:4.0.9),
          samba (<< 2:4.3.3+dfsg-1)
# these conflicts can NOT be replaced by 'Breaks'
# the old 3.6 packages should be removed before the new samba-libs is
# unpacked, to avoid any code referencing the old location of the tdb files
# see bug #726472
Conflicts: libpam-smbpass (<< 2:4),
           samba (<< 2:4),
           samba-common-bin (<< 2:4),
           samba-dsdb-modules (<< 2:4.1.9+dfsg-2),
           winbind (<< 2:4)
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Replaces: samba (<< 3.0.20b-1),
          samba-doc (<< 2:4.0.5~),
          samba4-common (<< 4.0.0~alpha7-1)
Conflicts: samba-doc (<< 2:4.0.5~), samba4-common (<< 4.0.0~alpha7-1), swat
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python,
         python-samba,
         samba-common (=${source:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Conflicts: samba (<< 2:3.3.0~rc2-5),
           samba-common (<< 2:3.3.0~rc2-5),
           samba-doc (<< 2:4.0.5~)
Replaces: python-samba (<< 2:4.0.6~),
          samba-common (<< 2:3.4.0~pre2-1),
          samba-doc (<< 2:4.0.5~),
          samba4-common (<< 4.0.0~alpha7-1),
          samba4-common-bin
Suggests: heimdal-clients
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.6~)
Replaces: samba (<< 2.999+3.0.alpha21-4),
          samba-doc (<< 2:4.0.5~),
          samba4-clients (<< 4.0.5),
          smbget
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Conflicts: samba-doc (<< 2:4.0.5~), samba4-clients (<< 4.0.5)
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Replaces: samba-doc (<< 2:4.0.5~),
          samba-libs (<< 2:4.0.10+dfsg-4),
          samba-tools,
          samba4-testsuite
Conflicts: samba-doc (<< 2:4.0.5~), samba-libs (<< 2:4.0.10+dfsg-4)
Depends: samba-common-bin, ${misc:Depends}, ${shlibs:Depends}
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: samba-doc (<< 2:4.0.5~)
Conflicts: samba-doc (<< 2:4.0.5~)
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: libparse-yapp-perl, ${misc:Depends}, ${perl:Depends}
Recommends: samba-dev
Suggests: libwireshark-dev
Section: perl
Description: IDL compiler written in Perl
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba-dev
Architecture: any
Depends: libc6-dev,
         libldb-dev,
         libparse-pidl-perl,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev (>= 1.2.11),
         libtevent-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
Section: devel
Replaces: libdcerpc-dev (<< 2:4.0.9),
          libdcerpc-server-dev (<< 2:4.0.9),
          libgensec-dev (<< 2:4.0.9),
          libndr-dev (<< 2:4.0.9),
          libndr-standard-dev (<< 2:4.0.9),
          libnetapi-dev (<< 2:4.0.9),
          libregistry-dev (<< 2:4.0.9),
          libsamba-credentials-dev (<< 2:4.0.9),
          libsamba-hostconfig-dev (<< 2:4.0.9),
          libsamba-policy-dev (<< 2:4.0.9),
          libsamba-util-dev (<< 2:4.0.9),
          libsamdb (<< 2:4.0.9),
          libsmbclient-raw-dev (<< 2:4.0.9),
          libsmbd-dev (<< 2:4.0.9),
          libtorture-dev (<< 2:4.0.9),
          samba4-dev
Breaks: libdcerpc-dev (<< 2:4.0.9),
        libdcerpc-server-dev (<< 2:4.0.9),
        libgensec-dev (<< 2:4.0.9),
        libndr-dev (<< 2:4.0.9),
        libndr-standard-dev (<< 2:4.0.9),
        libnetapi-dev (<< 2:4.0.9),

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

PYVERS=$(shell pyversions -vr)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_EPOCH = $(shell dpkg-query -f '$${Version}' -W libldb-dev | sed 's/:.*//')
LDB_NEXT_VERSION = $(shell python -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print '.'.join(x)")
# samba ships ldb modules, which are specific to the ldb version, so we need a
# strict dependency on the upstream ldb version
# this also mean samba needs a rebuild when the upstream ldb version changes
LDB_DEPENDS = "libldb1 (<< $(LDB_EPOCH):$(LDB_NEXT_VERSION)~), libldb1 (>> $(LDB_EPOCH):$(LDB_VERSION)~)"
export PYSHORT=$(shell pyversions -d)
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"
WAF = $(PYTHON) ./buildtools/bin/waf -v

# turn DEB_BUILD_OPTIONS='foo,bar' into DEB_BUILD_OPT_FOO and DEB_BUILD_OPT_BAR
d_b_o:=$(shell echo "$$DEB_BUILD_OPTIONS"|sed 's/[^-[:alnum:]]/ /g'|tr a-z A-Z)
$(foreach o, $(d_b_o), $(eval DEB_BUILD_OPT_$o := 1))

# for xsltproc wrapper
export PATH:=$(CURDIR)/debian/bin:$(PATH)
export SOURCE_DATE=$(shell debian/get_source_changedate.pl)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

conf_args = \
		--prefix=/usr \
		--enable-fhs \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-privatedir=/var/lib/samba/private \
		--with-smbpasswd-file=/etc/samba/smbpasswd \
		--with-piddir=/var/run/samba \
		--with-pammodulesdir=/lib/$(DEB_HOST_MULTIARCH)/security \
		--with-pam \
		--with-syslog \
		--with-utmp \
		--with-pam_smbpass \
		--with-winbind \
		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,vfs_dfs_samba4,auth_samba4 \
		--with-automount \
		--with-ldap \
		--with-ads \
		--with-dnsupdate \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba \
		--datadir=/usr/share \
		--with-lockdir=/var/run/samba \
		--with-statedir=/var/lib/samba \
		--with-cachedir=/var/cache/samba \
		--disable-avahi \
		--disable-rpath \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser,roken,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
		--builtin-libraries=replace,ccan,samba-cluster-support \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)"

%:
	dh $* --with python2

override_dh_auto_configure:
	$(shell dpkg-buildflags --export=configure) $(WAF) configure \
		$(conf_args)

override_dh_auto_clean:
	-$(WAF) clean
	find . -name "*.pyc" | xargs rm -f
	rm -rf buildtools/bin/.waf-*
	rm -rf bin
	rm -f .lock-wscript

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install

override_dh_auto_build:
	ulimit -s unlimited; DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_install:
	# get list of files in build log
	find ${DESTDIR}
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.so
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already documented in debian/copyright
	-rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	# pam stuff
	mkdir -p $(DESTDIR)/usr/share/pam-configs
	install -m 0644 debian/libpam-smbpass.pam-config $(DESTDIR)/usr/share/pam-configs/smbpasswd-migrate
	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
	# we don't ship the symlinks
	rm $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/libnss_*.so
	#Remove unused ldb share configuration plugin
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba/share/ldb.so
	#Remove unused vfstest manpage as there is no more vfstest apparently
	rm $(DESTDIR)/usr/share/man/man1/vfstest.1
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/winbind_krb5_locator.so \
	   $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	mkdir -p $(DESTDIR)/usr/lib/tmpfiles.d
	echo "d /run/samba 0755 root root -" > $(DESTDIR)/usr/lib/tmpfiles.d/samba.conf
	# Install samba-common's conffiles - they'll get moved later to their
	# correct place by dh_install
	cp debian/smb.conf* $(DESTDIR)/usr/share/samba/
	install -m755 debian/panic-action $(DESTDIR)/usr/share/samba/panic-action
	cp debian/gdbcommands $(DESTDIR)/etc/samba/
	mkdir -p $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d
	install -m755 debian/samba-common.dhcp $(DESTDIR)/etc/dhcp/dhclient-enter-hooks.d/samba
	# Ubuntu things
	mkdir -p $(DESTDIR)/etc/ufw/applications.d
	install -m644 debian/samba.ufw.profile $(DESTDIR)/etc/ufw/applications.d/samba
	mkdir -p $(DESTDIR)/usr/share/apport/package-hooks
	install -D -m 644 debian/source_samba.py $(DESTDIR)/usr/share/apport/package-hooks/source_samba.py
	# Install other stuff not installed by "make install"
	install -m 0755 debian/mksmbpasswd.awk $(DESTDIR)/usr/sbin/mksmbpasswd
	mkdir -p debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba
	mv $(DESTDIR)/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab.so \
	   debian/samba/usr/lib/$(PYSHORT)/dist-packages/samba/dckeytab.so
	# use upstream version of smb.conf.5 if there is no built version
	# this is a temporary workaround for #750593 in xsltproc
	[ -e $(DESTIDR)/usr/share/man/man5/smb.conf.5 ] || \
	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
	# Tests that shouldn't be installed
	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing

override_dh_python2:
	dh_python2 --no-guessing-versions

override_dh_installpam:
	dh_installpam --name=samba

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_installchangelogs:
	dh_installchangelogs -Nlibpam-smbpass
ifneq (,$(filter libpam-smbpass, $(shell dh_listpackages)))
	dh_installchangelogs -plibpam-smbpass source3/pam_smbpass/CHANGELOG
endif

override_dh_installinit:
ifneq (,$(filter samba, $(shell dh_listpackages)))
	dh_installinit -psamba --name smbd
	dh_installinit -psamba --name nmbd
	dh_installinit -psamba --name samba-ad-dc
	dh_installinit -psamba --noscripts
	dh_installinit -psamba --no-start --name reload-smbd
endif
ifneq (,$(filter winbind, $(shell dh_listpackages)))
	dh_installinit -pwinbind
endif

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba:$$LD_LIBRARY_PATH dh_shlibdeps -a

override_dh_gencontrol:
	dh_gencontrol -- -Vldb:Depends=$(LDB_DEPENDS)

override_dh_makeshlibs:
	# create symbols and shlibs files in separate wrapper script to deal with
	# private libraries
	debian/make_shlibs

override_dh_strip:
	# add debug symbols for all samba packages to the same debug package
	dh_strip -a --dbg-package=samba-dbg

override_dh_fixperms:
	dh_fixperms
ifneq (,$(filter samba-common, $(shell dh_listpackages)))
	chmod a+x debian/samba-common/usr/share/samba/panic-action
	# Set some reasonable default perms for the samba logdir.
	chmod 0750 debian/samba-common/var/log/samba/
	chown root:adm debian/samba-common/var/log/samba/
endif
ifneq (,$(filter samba, $(shell dh_listpackages)))
	chmod 1777 debian/samba/var/spool/samba/
endif

## samba 4.3.11%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,14 @@
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 endif
+
+ctdb_conf_args = \
+		--prefix=/usr \
+		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		--sysconfdir=/etc \
+		--localstatedir=/var \
+		--with-socketpath=/var/run/ctdb/ctdbd.socket \
+		--with-logdir=/var/log/ctdb \
 
 conf_args = \
 		--prefix=/usr \
@@ -46,7 +54,7 @@
 		--with-utmp \
 		--with-pam_smbpass \
 		--with-winbind \
-		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,vfs_dfs_samba4,auth_samba4 \
+		--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4 \
 		--with-automount \
 		--with-ldap \
 		--with-ads \
@@ -62,31 +70,52 @@
 		--disable-rpath-install \
 		--bundled-libraries=NONE,pytevent,iniparser,roken,wind,hx509,asn1,heimbase,hcrypto,krb5,gssapi,heimntlm,hdb,kdc,com_err,compile_et,asn1_compile \
 		--builtin-libraries=replace,ccan,samba-cluster-support \
-		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)"
+		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
+		--with-cluster-support
 
 %:
-	dh $* --with python2
+	dh $* --with python2 --with systemd
 
 override_dh_auto_configure:
+	cd ctdb; $(shell dpkg-buildflags --export=configure) ./configure $(ctdb_conf_args)
 	$(shell dpkg-buildflags --export=configure) $(WAF) configure \
 		$(conf_args)
 
 override_dh_auto_clean:
 	-$(WAF) clean
+	dh_auto_clean --sourcedirectory=ctdb
 	find . -name "*.pyc" | xargs rm -f
 	rm -rf buildtools/bin/.waf-*
 	rm -rf bin
 	rm -f .lock-wscript
 
 override_dh_auto_install:
+	dh_auto_install --sourcedirectory=ctdb
 	DESTDIR="$(DESTDIR)" $(WAF) install
 
 override_dh_auto_build:
+	dh_auto_build --sourcedirectory=ctdb
 	ulimit -s unlimited; DESTDIR="$(DESTDIR)" $(WAF)
 
 override_dh_auto_test:
 	# Running make test requires configuration with --enable-selftest, which
 	# we don't want to do for production systems.
+
+override_dh_systemd_start:
+	dh_systemd_start -pctdb --no-start --no-restart-on-upgrade
+
+override_dh_installdocs:
+	cp ctdb/config/events.d/README ctdb/README.eventscripts
+	cp ctdb/config/notify.d.README ctdb/README.notify.d
+	dh_installdocs
+ifeq ($(DEB_BUILD_ARCH_OS), hurd)
+	dh_installdocs -pctdb debian/ctdb.README.hurd
+endif
+ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
+	dh_installdocs -pctdb debian/ctdb.README.kfreebsd
+endif
+	#patch doc
+	sed -i 's|/etc/sysconfig/|/etc/default/|' $(CURDIR)/debian/ctdb/usr/share/doc/ctdb/web/*.html
 
 override_dh_install:
 	# get list of files in build log
@@ -101,7 +130,6 @@
 	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
 	# pam stuff
 	mkdir -p $(DESTDIR)/usr/share/pam-configs
-	install -m 0644 debian/libpam-smbpass.pam-config $(DESTDIR)/usr/share/pam-configs/smbpasswd-migrate
 	install -m 0644 debian/winbind.pam-config $(DESTDIR)/usr/share/pam-configs/winbind
 	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
 	# we don't ship the symlinks
@@ -140,6 +168,21 @@
 	   cp docs/manpages/smb.conf.5 $(DESTDIR)/usr/share/man/man5/smb.conf.5
 	# Tests that shouldn't be installed
 	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
+	# Remove ctdb dev files
+	rm $(DESTDIR)/usr/include/samba-4.0/ctdb*.h
+	rm $(DESTDIR)/usr/include/ctdb*.h
+	rm $(DESTDIR)/usr/lib/*/pkgconfig/ctdb.pc
+	# Remove ctdb tests
+	rm $(DESTDIR)/usr/bin/ctdb_run_tests
+	rm $(DESTDIR)/usr/bin/ctdb_run_cluster_tests
+	rm -rf $(DESTDIR)/usr/lib/*/ctdb-tests
+	rm -rf $(DESTDIR)/usr/share/ctdb-tests
+	# Remove libpam-smbpass, which is broken and slated for removal upstream.
+	rm -f $(DESTDIR)/lib/*/security/pam_smbpass.so
+	rm -f $(DESTDIR)/usr/bin/async_connect_send_test
+	# Install ctdb conffiles
+	mkdir -p $(DESTDIR)/lib/systemd/system/
+	install -m 0644 ctdb/config/ctdb.service $(DESTDIR)/lib/systemd/system/
 	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing
 
 override_dh_python2:
@@ -152,46 +195,6 @@
 	./debian/build-orig.sh
 
 override_dh_installchangelogs:
-	dh_installchangelogs -Nlibpam-smbpass
-ifneq (,$(filter libpam-smbpass, $(shell dh_listpackages)))
-	dh_installchangelogs -plibpam-smbpass source3/pam_smbpass/CHANGELOG
-endif
+	dh_installchangelogs
 
 override_dh_installinit:
-ifneq (,$(filter samba, $(shell dh_listpackages)))
-	dh_installinit -psamba --name smbd
-	dh_installinit -psamba --name nmbd
-	dh_installinit -psamba --name samba-ad-dc
-	dh_installinit -psamba --noscripts
-	dh_installinit -psamba --no-start --name reload-smbd
-endif
-ifneq (,$(filter winbind, $(shell dh_listpackages)))
-	dh_installinit -pwinbind
-endif
-
-override_dh_shlibdeps:
-	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba:$$LD_LIBRARY_PATH dh_shlibdeps -a
-
-override_dh_gencontrol:
-	dh_gencontrol -- -Vldb:Depends=$(LDB_DEPENDS)
-
-override_dh_makeshlibs:
-	# create symbols and shlibs files in separate wrapper script to deal with
-	# private libraries
-	debian/make_shlibs
-
-override_dh_strip:
-	# add debug symbols for all samba packages to the same debug package
-	dh_strip -a --dbg-package=samba-dbg
-
-override_dh_fixperms:
-	dh_fixperms
-ifneq (,$(filter samba-common, $(shell dh_listpackages)))
-	chmod a+x debian/samba-common/usr/share/samba/panic-action
-	# Set some reasonable default perms for the samba logdir.
-	chmod 0750 debian/samba-common/var/log/samba/
-	chown root:adm debian/samba-common/var/log/samba/
-endif
-ifneq (,$(filter samba, $(shell dh_listpackages)))
-	chmod 1777 debian/samba/var/spool/samba/
-endif

=== debian/tests/control ===
Tests: python-smoke
Depends: python-samba
